;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;~Xe[{bNX({X)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
                    EXTRA_BITS = $7FAB10
                    USE_WALKING_ENDING = $00    ; $00 or $01 depending on ending desired
                    MUSIC_TO_PLAY = $0C         ; $0C = regular, $0B = boss
INITIAL_HP = 9			;HP
EFFECT_SOUND_1 = $01		;uԈړ҂ɖ炷ʉ
EFFECT_SOUND_1_FRAME = %00000011	;t[1炷
EFFECT_SOUND_2 = $2C		;uԈړɖ炷ʉ
WAITED_TIME = $30			;uԈړ̑҂+1
EXTRA_SPRITE_TIME = %00000111	;GLXgXvCg𓊂鎞
EXTRA_SPRITE_KIND = $04		;ȂGLXgXvCg̎
BLOCK_KIND_16X = $030B		;ubN16ԍ
				;(dlɂȂĂ̂
				;@@@@@@@@@ςȂƃoO܂B)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite data
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; init JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "INIT"
	STZ $1570,x	;\
	STZ $1504,x	; |
	STZ $151C,x	;  >
	STZ $1540,x	; |
	STZ $1594,x	; |
	STZ $1558,x	; |
	STZ $1564,x	; |
	STZ $160E,x	;/
	LDA #INITIAL_HP		;\
	STA $06B4		; |
	LDA #$02			;  >̗͐̏ݒ
	STA $19			;/
                    RTL

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    dcb "MAIN"
                    PHB                     ; \
                    PHK                     ;  | main sprite function, just calls local subroutine
                    PLB                     ;  |
                    JSR START_HB_CODE       ;  |
                    PLB                     ;  /
LDA $0014			;t[JE^
	BNE RETURN2
	JSR GEN_BLK		;ubN
                    RTL                     ; 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main sprite routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN2		RTL
RETURN              RTS                    
START_HB_CODE       JSR SUB_GFX
                    LDA $14C8,x
                    CMP #$08
                    BNE RETURN
                    LDA $9D
                    BNE RETURN
                    JSR SUB_OFF_SCREEN_X3   ; only process sprite while on screen

LBL012	LDA $0F31		;\
	BNE LBL010		; |
	LDA $0F32		; |
	BNE LBL010		; |
	LDA $0F33		;  >^Cǂݎ
	CMP #$01			; |@@@1S[
	BEQ LBL013		; |
	JMP LBL010		;/

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;S[
;;;;;;;;;;;;;;;;;;;;;;;;;;
LBL013	LDA #$04
	STA $14C8,x
                    LDA #$FF                ; \ set time before return to overworld
                    STA $1493               ; /
                    LDA EXTRA_BITS,x        ; set secret exit if first extra bit is set
                    LSR A
                    LSR A
                    LSR A
                    AND #$01
                    EOR #$01
                    STA $141C
                    LDA #USE_WALKING_ENDING
                    BNE WALK
                    DEC $13C6               ; prevent mario from walking at level end
WALK                LDA #$0C                ; \ change music 0C for regular end, 0B for boss end
                    STA $1DFB               ; /
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LBL010	LDA $1540,x	;
	BNE LBL004	;uԈړ҂ԂȂ
	JMP LBL005	;

LBL004	LDA $0014	;
	AND #EFFECT_SOUND_1_FRAME	;t[1
	BEQ LBL006			;ʉ炷Ƃɔ
	JMP LBL005	;

LBL006	LDA #EFFECT_SOUND_1		;ʉ炷
	STA $1DFC	;

LBL005	LDA $0014	;255t[1uԈړ҂
	BEQ LBL001	;
	LDA $1540,x	;uԈړ҂
	CMP #$01		;@@@@@@@@IȂ
	BEQ LBL003	;@@@@@@@@@@@@@@΂
	JMP LBL002	;

LBL001	LDA $0096	;\
	STA $1504,x	; |
	LDA $0097	; |
	STA $151C,x	; |
	LDA $0094	;  >}ÏʒuL
	STA $1594,x	; |
	LDA $0095	; |
	STA $160E,x	;/
	LDA #WAITED_TIME		;uԈړ҂ɂ
	STA $1540,x	;
	JMP LBL002

LBL003	LDA $1504,x	;\
	STA $D8,x		; |
	LDA $151C,x	; |
	STA $14D4,x	; |
	LDA $1594,x	;  >LĒulXgA(uԈړ)
	STA $E4,x		; |
	LDA $160E,x	; |
	STA $14E0,x	;/
	LDA #EFFECT_SOUND_2		;
	STA $1DFC	;ʉ炷
	JMP LBL002

LBLGO008	JMP LBL008

LBL002	LDA $0014	;
	AND #EXTRA_SPRITE_TIME	;t[1
	BNE LBLGO008	;GLXgXvCg𓊂

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;GLXgXvCg
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_EXTRA           LDY #$07		
EXTRA_LOOP          LDA $170B,y	
                    BEQ EXTRA_1		
                    DEY
                    BPL EXTRA_LOOP
                    JMP LBLGO008
EXTRA_1             LDA #EXTRA_SPRITE_KIND    ;XvCg̎
                    STA $170B,y 

                    LDA $E4,x   ;xWʃoCg
                    STA $171F,y 
                    LDA $14E0,x ;xWʃoCg
                    STA $1733,y 
                    
                    LDA $D8,x   ;yWʃoCg
                    STA $1715,y 
                    LDA $14D4,x ;yWʃoCg
                    STA $1729,y 

	JSL $01ACF9	;
                    LDA $148D   ;yx(̏ꍇׂ͂ė)
                    STA $173D,y 
                    LDA $148E   ;xx
                    STA $1747,y 

                    LDA #$FF   ;ꕔXvCgp̃^C}[
                    STA $176F,y 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;̗͐
;;;;;;;;;;;;;;;;;;;;;;;;;;;
LBL008	LDA $009D	;̗͐͂ĉĂ܂
	BNE RETURN3	;728񂪍̂Ȃ̂
	JMP MYDMG	

RETURN3	JMP LBL011
MYDMG
	LDA $19
	CMP #$02
	BEQ MYDMGEND
	LDA #$02
	STA $19
	LDA $06B4
	DEC
	STA $06B4
	CMP #$00
	BNE MYDMGEND
	JSL $00F606
MYDMGEND
	LDA #$16
	STA $0EFA
	LDA #$FC
	STA $0EF9
	STA $0F1C
	LDA #$26
	STA $0EFB
	STA $0EFC
	STA $0EFD
	STA $0EFE
	STA $0EFF
	STA $0F00

	LDY #$00
GADE
	LDA #$00
	CMP $06B4
	BEQ GADEND
	LDA #$2E
	STA $0EFB,y
	INY
	CPY $06B4
	BCC GADE
GADEND


LBL011	JSL $018022

                    JSL $01A7DC
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; graphics routine
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
TILEMAP       dcb $2e,$40,$c0,$2a     ;1Ԗڂ̃Aj[VɎg4̃^C
                    dcb $40,$c0,$2a,$2e     ;2Ԗڂ̃Aj[VɎg4̃^C
                    dcb $c0,$2a,$2e,$40     ;3Ԗڂ̃Aj[VɎg4̃^C
                    dcb $2a,$2e,$40,$c0     ;4Ԗڂ̃Aj[VɎg4̃^C
X_OFFSET            dcb $10,$00,$10,$00,$00,$10,$00,$10     ;E^CxW/^CxW
Y_OFFSET            dcb $00,$00,$10,$10     ;^CyW

SUB_GFX             JSR GET_DRAW_INFO       ; sets y = OAM offset
                    LDA $157C,x             ; \ $02 = direction
                    ASL A
                    ASL A
                    STA $02                 ; /     
                    LDA $14
                    LSR A
                    LSR A
                    LSR A
                    AND #$03
                    ASL A
                    ASL A
                    STA $03             
                    
                    PHX
                    LDX #$03

LOOP_START          PHX
                    TXA
                    CLC
                    ADC $02
                    TAX
                    LDA X_OFFSET,x
                    CLC
                    ADC $00                 ; \ tile x position = sprite y location ($01)
                    STA $0300,y             ; /
                    PLX

                    LDA Y_OFFSET,x
                    CLC
                    ADC $01                 ; \ tile y position = sprite x location ($00)
                    STA $0301,y             ; /
                    
                    PHX
                    TXA
                    CLC
                    ADC $03
                    TAX
                    LDA TILEMAP,x
                    STA $0302,y 
                    PLX
                    
                    PHX
                    LDX $15E9
                    LDA $15F6,x             ; tile properties xyppccct, format
                    LDX $02                 ; \ if direction == 0...
                    BNE NO_FLIP             ;  |
                    ORA #$40                ; /    ...flip tile
NO_FLIP             ORA $64                 ; add in tile priority of level
                    STA $0303,y             ; store tile properties
                    PLX
                    INY                     ; \ increase index to sprite tile map ($300)...
                    INY                     ;  |    ...we wrote 1 16x16 tile...
                    INY                     ;  |    ...sprite OAM is 8x8...
                    INY                     ; /    ...so increment 4 times
                    DEX
                    BPL LOOP_START

                    PLX
                    LDY #$02                ; \ 460 = 2 (all 16x16 tiles)
                    LDA #$03                ;  | A = (number of tiles drawn - 1)
                    JSL $01B7B3             ; / don't draw if offscreen
                    RTS                     ; return



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; $B760 - graphics routine helper - shared
; sets off screen flags and sets index to OAM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B75C

TABLE1              dcb $0C,$1C
TABLE2              dcb $01,$02

GET_DRAW_INFO       STZ $186C,x             ; reset sprite offscreen flag, vertical
                    STZ $15A0,x             ; reset sprite offscreen flag, horizontal
                    LDA $E4,x               ; \
                    CMP $1A                 ;  | set horizontal offscreen if necessary
                    LDA $14E0,x             ;  |
                    SBC $1B                 ;  |
                    BEQ ON_SCREEN_X         ;  |
                    INC $15A0,x             ; /

ON_SCREEN_X         LDA $14E0,x             ; \
                    XBA                     ;  |
                    LDA $E4,x               ;  |
                    REP #$20                ;  |
                    SEC                     ;  |
                    SBC $1A                 ;  | mark sprite invalid if far enough off screen
                    CLC                     ;  |
                    ADC.W #$0040            ;  |
                    CMP.W #$0180            ;  |
                    SEP #$20                ;  |
                    ROL A                   ;  |
                    AND #$01                ;  |
                    STA $15C4,x             ; / 
                    BNE INVALID             ; 
                    
                    LDY #$00                ; \ set up loop:
                    LDA $1662,x             ;  | 
                    AND #$20                ;  | if not smushed (1662 & 0x20), go through loop twice
                    BEQ ON_SCREEN_LOOP      ;  | else, go through loop once
                    INY                     ; / 
ON_SCREEN_LOOP      LDA $D8,x               ; \ 
                    CLC                     ;  | set vertical offscreen if necessary
                    ADC TABLE1,y            ;  |
                    PHP                     ;  |
                    CMP $1C                 ;  | (vert screen boundry)
                    ROL $00                 ;  |
                    PLP                     ;  |
                    LDA $14D4,x             ;  | 
                    ADC #$00                ;  |
                    LSR $00                 ;  |
                    SBC $1D                 ;  |
                    BEQ ON_SCREEN_Y         ;  |
                    LDA $186C,x             ;  | (vert offscreen)
                    ORA TABLE2,y            ;  |
                    STA $186C,x             ;  |
ON_SCREEN_Y         DEY                     ;  |
                    BPL ON_SCREEN_LOOP      ; /

                    LDY $15EA,x             ; get offset to sprite OAM
                    LDA $E4,x               ; \ 
                    SEC                     ;  | 
                    SBC $1A                 ;  | $00 = sprite x position relative to screen boarder
                    STA $00                 ; / 
                    LDA $D8,x               ; \ 
                    SEC                     ;  | 
                    SBC $1C                 ;  | $01 = sprite y position relative to screen boarder
                    STA $01                 ; / 
                    RTS                     ; return

INVALID             PLA                     ; \ return from *main gfx routine* subroutine...
                    PLA                     ;  |    ...(not just this subroutine)
                    RTS                     ; /

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; off screen processing code - shared
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

                    ;org $03B83B             

TABLE3              dcb $40,$B0
TABLE6              dcb $01,$FF 
TABLE4              dcb $30,$C0,$A0,$80,$A0,$40,$60,$B0 
TABLE5              dcb $01,$FF,$01,$FF,$01,$00,$01,$FF

SUB_OFF_SCREEN_X0   LDA #$06                ; \ entry point of routine determines value of $03
                    JMP STORE_03            ; | 
SUB_OFF_SCREEN_X1   LDA #$04                ; |
                    JMP STORE_03            ; |
SUB_OFF_SCREEN_X2   LDA #$02                ; |
STORE_03            STA $03                 ; |
                    JMP START_SUB           ; |
SUB_OFF_SCREEN_X3  STZ $03                 ; /

START_SUB           JSR SUB_IS_OFF_SCREEN   ; \ if sprite is not off screen, return
                    BEQ RETURN_2            ; /    
                    LDA $5B                 ; \  goto VERTICAL_LEVEL if vertical level
                    AND #$01                ; |
                    BNE VERTICAL_LEVEL      ; /     
                    LDA $D8,x               ; \
                    CLC                     ; | 
                    ADC #$50                ; | if the sprite has gone off the bottom of the level...
                    LDA $14D4,x             ; | (if adding 0x50 to the sprite y position would make the high byte >= 2)
                    ADC #$00                ; | 
                    CMP #$02                ; | 
                    BPL ERASE_SPRITE        ; /    ...erase the sprite
                    LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ 
                    AND #$01                ; | 
                    ORA $03                 ; | 
                    STA $01                 ; |
                    TAY                     ; /
                    LDA $1A
                    CLC
                    ADC TABLE4,y
                    ROL $00
                    CMP $E4,x
                    PHP
                    LDA $1B
                    LSR $00
                    ADC TABLE5,y
                    PLP
                    SBC $14E0,x
                    STA $00
                    LSR $01
                    BCC LABEL20
                    EOR #$80
                    STA $00
LABEL20             LDA $00
                    BPL RETURN_2
ERASE_SPRITE        LDA $14C8,x             ; \ if sprite status < 8, permanently erase sprite
                    CMP #$08                ; |
                    BCC KILL_SPRITE         ; /
                    LDY $161A,x
                    CPY #$FF
                    BEQ KILL_SPRITE
                    LDA #$00
                    STA $1938,y
KILL_SPRITE         STZ $14C8,x             ; erase sprite
RETURN_2            RTS                     ; return

VERTICAL_LEVEL      LDA $167A,x             ; \ if "process offscreen" flag is set, return
                    AND #$04                ; |
                    BNE RETURN_2            ; /
                    LDA $13                 ; \ only handle every other frame??
                    LSR A                   ; | 
                    BCS RETURN_2            ; /
                    AND #$01
                    STA $01
                    TAY
                    LDA $1C
                    CLC
                    ADC TABLE3,y
                    ROL $00
                    CMP $D8,x
                    PHP
                    LDA.W $001D
                    LSR $00
                    ADC TABLE6,y
                    PLP
                    SBC $14D4,x
                    STA $00
                    LDY $01
                    BEQ LABEL22
                    EOR #$80
                    STA $00
LABEL22             LDA $00
                    BPL RETURN_2
                    BMI ERASE_SPRITE

SUB_IS_OFF_SCREEN   LDA $15A0,x             ; \ if sprite is on screen, accumulator = 0 
                    ORA $186C,x             ; |  
                    RTS                     ; / return

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ubN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GEN_BLK           LDA $E4,x   ;xWoCg
CLC
ADC #$05
                    AND #$F0
                    STA $9A
                    LDA $14E0,x ;xWoCg
ADC #$00
                    STA $9B
                    LDA $D8,x   ;yWoCg
                    AND #$F0
                    STA $98
                    LDA $14D4,x ;yWoCg
                    STA $99
                    REP #$30
                    LDA.W #BLOCK_KIND_16X  ;^C16xԍ 
                    JSR SUBL_SET_MAP16
                    SEP #$30
                    RTS

SUBL_SET_MAP16      PHX                     
                    TAX                                       
                    JSR SUB_8034                      
                    PLX                                          
                    RTS                    

RETURN18            PLX
                    PLB
                    RTS

SUB_8034            SEP #$20                
                    PHB                     
                    LDA #$00                 
                    PHA                  
                    PLB                   
                    REP #$30                 
                    PHX                     
                    LDA $9A
                    STA $0C
                    LDA $98
                    STA $0E
                    LDA.W #$0000
                    SEP #$20
                    LDA $5B
                    STA $09
                    LDA $1933
                    BEQ NO_SHIFT
                    LSR $09
NO_SHIFT            LDY $0E
                    LDA $09
                    AND #$01
                    BEQ HORIZ
                    LDA $9B
                    STA $00
                    LDA $99
                    STA $9B
                    LDA $00  
                    STA $99
                    LDY $0C
HORIZ               CPY.W #$0200
                    BCS RETURN18
                    LDA $1933
                    ASL A
                    TAX
                    LDA $BEA8,x
                    STA $65
                    LDA $BEA9,x
                    STA $66
                    STZ $67
                    LDA $1925
                    ASL A
                    TAY
                    LDA ($65),y
                    STA $04
                    INY
                    LDA ($65),y
                    STA $05
                    STZ $06
                    LDA $9B
                    STA $07
                    ASL A
                    CLC
                    ADC $07
                    TAY
                    LDA ($04),y 
                    STA $6B
                    STA $6E
                    INY
                    LDA ($04),y
                    STA $6C
                    STA $6F
                    LDA #$7E
                    STA $6D
                    INC A
                    STA $70
                    LDA $09
                    AND #$01
                    BEQ NO_AND
                    LDA $99
                    LSR A
                    LDA $9B 
                    AND #$01
                    JMP LABEL52
NO_AND              LDA $9B
                    LSR A            
                    LDA $99            
LABEL52             ROL A            
                    ASL A             
                    ASL A             
                    ORA #$20           
                    STA $04            
                    CPX.W #$0000       
                    BEQ NO_ADD     
                    CLC
                    ADC #$10 
                    STA $04
NO_ADD              LDA $98                 
                    AND #$F0                
                    CLC
                    ASL A
                    ROL A
                    STA $05           
                    ROL A            
                    AND #$03         
                    ORA $04        
                    STA $06           
                    LDA $9A            
                    AND #$F0          
                    LSR A            
                    LSR A           
                    LSR A            
                    STA $04           
                    LDA $05           
                    AND #$C0         
                    ORA $04            
                    STA $07           
                    REP #$20         
                    LDA $09            
                    AND.W #$0001         
                    BNE LABEL51         
                    LDA $1A              
                    SEC                    
                    SBC.W #$0080            
                    TAX
                    LDY $1C
                    LDA $1933
                    BEQ LABEL50
                    LDX $1E
                    LDA $20
                    SEC
                    SBC.W #$0080
                    TAY
                    JMP LABEL50
LABEL51             LDX $1A
                    LDA $1C
                    SEC
                    SBC.W #$0080
                    TAY
                    LDA $1933
                    BEQ LABEL50
                    LDA $1E
                    SEC
                    SBC.W #$0080
                    TAX  
                    LDY $20
LABEL50             STX $08                
                    STY $0A               
                    LDA $98               
                    AND.W #$01F0          
                    STA $04              
                    LDA $9A              
                    LSR A                
                    LSR A                
                    LSR A                
                    LSR A                
                    AND.W #$000F          
                    ORA $04              
                    TAY                    
                    PLA              
                    SEP #$20               
                    STA [$6B],y
                    XBA                     
                    STA [$6E],y
                    XBA                    
                    REP #$20                
                    ASL A              
                    TAY                     
                    PHK                   
                    PER.W #$0006           
                    PEA $804C
                    JML $00C0FB
MAP16_RETURN        PLB
                    RTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;